CON
	_xinfreq		= 5_000_000		' Quartz is 5MHz
	_clkmode		= xtal1 + pll16x	' System clock is 80MHz

	io_cmd_out		=	$01		' I/O emulator command output
	io_cmd_in		=	$02		' I/O emulator command input
	io_cmd_break		=	$03		' I/O emulator command break
	io_cmd_kbd		=	$04		' I/O emulator command read TRS-80 keyboard

	baud			=	115200		' baud rate


#define CHECK_CONTIG
#define	PAL

VAR
	long	cog
	long	io_command
	long	iobuff[512*2/4]
	long	iobuff_ptr
	byte	curx
	byte	cury
	byte	de[32]					' directory entry
	byte	name[12+1]
	byte	datetime[20+1]

OBJ
	fdx	: "cserial"
	xmm	: "Dracblade"				' Extended memory manager
	sd	: "mb_rawb_spi26_rr006"

PUB main : okay | i
	iobuff_ptr := @iobuff

	fdx.start(31, 30, 0, 115200)

	okay := sd.start_explicit(12,13,14,15)
	if okay < 0
		failure(string("SD SPI"), okay)
		return -1
	success(string("SD SPI"))

	okay := \xmm.start
	if okay < 0
		failure(string("XMM"), okay)
		return -1
	success(string("XMM"))

	' clear the RAM
	longfill(iobuff_ptr, 0, 512/4)
	repeat i from $0000 to $fe00 step $200
		xmm.DoCmd("W", iobuff_ptr, i, $200)

	repeat i from 0 to $7ffffff
		okay := sd.readblock(i, iobuff_ptr)
		xmm.DoCmd("W", iobuff_ptr, i*512, $200)
		if i // 1024 == 0
			chr(" ")
			dec_size(512*i)

PRI chr(ch)
	fdx.tx(ch)

PRI str(str_ptr)
	fdx.str(str_ptr)

PRI crlf
	chr(13)
	chr(10)

PRI dec_size(value)
	if value > 1048576
		dec(value/1048576)
		chr(".")
		dec(10*(value // 1048576) / 1048576)
		str(string("MB"))
	elseif value > 1024
		dec(value/1024)
		chr(".")
		dec(10*(value // 1024) / 1024)
		str(string("KB"))
	else
		dec(value)

PRI dec(value)
	fdx.dec(value)

PRI hex(value, digits)
'' Print a hexadecimal number
	fdx.hex(value, digits)

PRI bin(value, digits)
'' Print a binary number
	fdx.bin(value, digits)


PRI failure(who, val)
	str(who)
	str(string(" failed: "))
	dec(val)
	crlf

PRI success(who) | i, n, n1, n2, n3, n4, n5, n6, n7
	str(who)
	str(string(" initialized, "))
	dec(free_cogs)
	str(string(" cogs free.", 13, 10))

PUB free_cogs : free | i, cogs[8], jmp_0
	jmp_0 := %010111_0001_1111_000000000_000000000
	repeat while (cogs[free] := cognew(@jmp_0, 0)) => 0 
		free++
	if free
		repeat i from 0 to free - 1
			cogstop(cogs[i])
	return free
